unit ThreadDemoThreadUnit;

interface

uses
  Classes, SysUtils, Windows,ThreadControllerUnit;

type
  ThreadDemoThread = class(TThread)
  private
    { Private declarations }
    FThreadController: TThreadController;
  protected
    procedure Execute; override;
  public
    constructor create(CreateSuspended: Boolean; ThreadController: TThreadController);
    destructor Destroy; override;
  end;

implementation

{ Important: Methods and properties of objects in VCL can only be used in a
  method called using Synchronize, for example,

      Synchronize(UpdateCaption);

  and UpdateCaption could look like,

    procedure ThreadDemoThread.UpdateCaption;
    begin
      Form1.Caption := 'Updated in a thread';
    end; }

{ ThreadDemoThread }

constructor ThreadDemoThread.create(CreateSuspended: Boolean; ThreadController: TThreadController);
begin
  //Always Create the inherited thread suspended to stop
  //it running before we have finished the constructor
  Inherited Create(True);

  //Do our initialization here
  FThreadController := ThreadController;
  FThreadController.AddThread(self);
  FreeOnTErminate := True;
  
  //If thread susposed to execute now resume it
  if not Createsuspended then
    Resume;
end;

destructor ThreadDemoThread.Destroy;
begin
  FThreadController.RemoveThread(Self);
  inherited;
end;

procedure ThreadDemoThread.Execute;
begin
  { Place thread code here }
  While not terminated do begin
    SysUtils.Beep;
    Sleep(5000);
  end;
end;

end.
 